=begin
------------------------------------------------------------------------
Copyright 2007, TIG (c)
Permission to use, copy, modify, and distribute this software for any 
purpose, and currently without fee, is hereby granted, provided that  
this text and the above copyright (c) notice appear in all copies.
This software is provided "as is" and without any express or implied 
warranties, including, without limitation, the implied warranties of 
merchantability and fitness for a particular purpose.
------------------------------------------------------------------------
Name        : Roof.rb
Author      : TIG
Description : A set of Roof Making Tools.
Menu Item   : Plugins > Roof... > Sub-Menus...
Usage       : See RoofHelp.mht file originally distributed with this.
			   There is also a .pdf version available.
Version     : 1.0	20070824	First issue.
			  1.1	20070826	A:B slope glitch fixed: array.to_f !
			  1.2	20070827	Rectangle checking OK =~ 90 degrees.
			  1.3	20070828	Fixed Gable Materials messed up by v1.2,
								gable 2 overhang glitches & spurious
								non-rectanglur face errors.
			  2.0	20070902	Dialogs redone to avoid Mac failures.
								Gable and Pyramid defs redone to picking
								3 points, rather than face/edge.
								Help redone.
------------------------------------------------------------------------
=end
eval %q{PWJlZ2luClNldmVyYWwgcGFydHMgYXJlIGluc3BpcmVkIGluIHBhcnQgYnkg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}.unpack("m").to_s
